package main

import (
	"database/sql"
    	"flag"
	"log"
	"os"
	"text/template"
	//"net/http"

	_ "github.com/mattn/go-sqlite3"
)

var BP string

type Post struct {
    Id int
    Content string
    File string
    Filename string
    Fileinfo string
    Imgprev string
}

type Thread struct {
    Board string
    Subject string
    Time string
    Posts []*Post
}

var max_conns = 5
var Conns = make(chan *sql.Stmt, max_conns)

func Err_check(err error) {
	if err != nil {
		log.Fatal(err)
	}
}

func Query_err_check(err error) {
	if err != nil {
	
		if err == sql.ErrNoRows {
			// there were no rows, but otherwise no error occurred
		} else {
				log.Fatal(err)
			} 
			
	}
}


func Checkout() *sql.Stmt {
  return <-Conns
}

func Checkin(c *sql.Stmt) {
  Conns <- c
}

func get_post(id int) Post {
 	conn, err := sql.Open("sqlite3", BP + "database/post-coll.db")
  	Err_check(err)

	stmt, err := conn.Prepare("SELECT Content, COALESCE(File, '') AS File, COALESCE(Filename, '') AS Filename, COALESCE(Fileinfo, '') AS Fileinfo, COALESCE(Imgprev, '') Imgprev FROM posts WHERE id = ?")
	Err_check(err)

	var content string
	var file string
	var filename string
	var fileinfo string
	var imgprev string

	row := stmt.QueryRow(id)

	err = row.Scan(&content, &file, &filename, &fileinfo, &imgprev)
	Query_err_check(err)

	return Post{Id: id, Content: content, File: file, Filename: filename, Fileinfo: fileinfo, Imgprev: imgprev} 
}

func main() {

    flag.StringVar(&BP, "BP", "./", "the base path")
    flag.Parse()

    threadtemp := template.New("thread.html")
    threadtemp, err := threadtemp.ParseFiles(BP + "/templates/thread.html")
    Err_check(err)

    f, err := os.Create(BP + "index.html")
    Err_check(err)
    defer f.Close()

    p1 := get_post(1)
    p2 := get_post(2)
    p3 := get_post(3)
    p4 := get_post(4)
    p5 := get_post(5)
    p6 := get_post(6)

    thread := Thread{Posts: []*Post{&p1, &p2, &p3, &p4, &p5, &p6}, Subject: "Templates", Time: "4/30/22(Thu)01:30:45"}

    threadtemp.Execute(f, thread)
/*

	for i := 0; i < max_conns; i++ {
 		conn, err := sql.Open("sqlite3", "/mnt/c/server/data/content/media/toggle/database/post-coll.db")
  		Err_check(err)
		stmt, _ := conn.Prepare("SELECT content FROM posts WHERE id = ?")

  		defer func() {
			stmt.Close()
      			conn.Close()
  		}()
  		Conns <- stmt
	}

	//listen mux
	mux := http.NewServeMux()
	mux.HandleFunc("/im/ret/", Retrieve)
	mux.HandleFunc("/im/post/", Newpost)
	http.ListenAndServe(":81", mux)
*/
} 
